Elgoh={};
function Elgoh.UnitTooltip(tooltip)
	local person,unit=tooltip:GetUnit();	
	if(not UnitIsPlayer(unit)) then return; end
	if(person==Elgoh.Disenchanter) then 
		tooltip:AddLine("Disenchanter", 0.2,1,0.2);
	end
	tooltip:Show();
end

function Elgoh.UnitPopupClick(self, arg1, arg2, checked)
	local name, server = UnitName(UIDROPDOWNMENU_INIT_MENU.name)
	if(name==nil) then return end
	
	Elgoh.Disenchanter=name;
	ElPrint(name.." is now the Disenchanter");
	--	SendChatMessage(name.." is now the Disenchanter", "RAID");
	if(Elgoh.LootFinishedDEButton~=nil) then
		Elgoh.LootFinishedDEButton.tooltipText="Send "..Elgoh.CurrentItem.." to "..Elgoh.Disenchanter;
	end	
	if(Elgoh.LootButton~=nil and Elgoh.LootButton[9]~=nil) then
		for i=1,4 do
			Elgoh.LootButton[i+8].tooltipText="Send to "..Elgoh.Disenchanter;
		end
	end
end

local upgrade_warned=false;
local partloaded=0;
function Elgoh.onEvent(self,event, ...)
	if(event=="CHAT_MSG_ADDON") then
		local prefix, msg, how, who = ...;		
		if(prefix=="elgoh") then
			if(msg:find("^vers")) then
				local vers=msg:sub(5)
				ElDebug(who.." has "..msg);
				if(tonumber(msg)>(tonumber(Elgoh.Version)) and not upgrade_warned) then 
					ElPrint("A new version is available from Curse ("..msg..", you've got "..Elgoh.Version..")"); 
					upgrade_warned=true; 
				end
			end
			if(CanEditOfficerNote()==true and msg:find("^!")~=nil) then
				ElDebug("Being Queried for "..string.sub(msg,2).."...");
				for i = 1, GetNumGuildMembers(), 1 do
					local name,_,_,_,_,_,_,officernote = GetGuildRosterInfo(i);
					if(name==string.sub(msg,2)) then
						local EDBString=string.match(officernote, "$(.*)%$");
						if(EDBString~="" and EDBString~=nil) then
							SendAddonMessage("Elgoh.", "$"..name.."$"..EDBString, "WHISPER", who);
							ElDebug("Sending $"..name.."$"..EDBString);
						end
					end
				end
			elseif(CanEditOfficerNote()~=true and string.find(msg,"^%$")~=nil) then
				ElDebug("Officer Reply...");
				Elgoh.WaitingOnOfficer=false;
				who=msg:match("^$(.*)%$");
				msg=string.sub(msg,who:len()+3);
				ElDebug(msg);
				local Earned,Spent,Priority=strsplit(":",msg);
				Earned=tonumber(Earned);
				Spent=tonumber(Spent);
				Priority=tonumber(Priority);
				
				EDB[who]={};
				EDB[who]["earned"]=Earned;
				EDB[who]["spent"]=Spent;
				EDB[who]["priority"]=Priority;
				Elgoh.UpdateLines(EDB.selected);
			end
		end
	elseif(event=="CHAT_MSG_SYSTEM") then
		local message=...; if(message:find("rolls %d+"))==nil then return; end
		local name=strmatch(message, "^(%a+) ");
		--ElDebug(name.." rolled!");
		Elgoh.RaiderInterested(name);
	elseif(event=="CHAT_MSG_RAID_WARNING") then
		if(Elgoh.Rolling==1) then return; end
		for i=1, GetNumGroupMembers(), 1 do 
			local name, rank,_,_,_,_,_,_,_, role, isML = GetRaidRosterInfo(i);
			if(name==UnitName("PLAYER") and (isML or Elgoh_Settings.Debug==1)) then
				local message,who=...; if(message:find("|h%["))==nil then ElDebug("No itemLink"); return; end
				local item=string.match(message, "(%[.+%])");
				ElDebug("Item: "..item);
				Elgoh.LootingReset();
				Elgoh.Rolling=1;
				Elgoh.CurrentItem=message:match("(|cff.+|r)");
				Elgoh.RefreshLootList();
				return;
			end
		end
	elseif(event=="CHAT_MSG_WHISPER") then
		local message,who=...; 
		if(message:find("^!dkp")==nil and message:find("^!dpl")==nil) then 
			return; 
		end
		Elgoh.DKPWhisper(who);
	elseif(event=="LOOT_OPENED" or event=="LOOT_SLOT_CLEARED" or event=="LOOT_SLOT_CHANGED" or event=="LOOT_CLOSED") then
		if(Elgoh_Settings.Debug==1) then Elgoh.LootShow(); end
		if(GetNumGroupMembers()==0) then return; end
		Elgoh.LootShow();
	elseif(event == "ADDON_LOADED") then
		addon=...;
		if(addon:lower()=="elgoh") then
			if(partloaded==1) then Elgoh.frmMain:UnregisterEvent("ADDON_LOADED"); end
			partloaded=1;
			Elgoh.frmMain:RegisterEvent("CHAT_MSG_ADDON");
			Elgoh.frmMain:RegisterEvent("CHAT_MSG_WHISPER");
			Elgoh.frmMain:RegisterEvent("LOOT_OPENED");
			Elgoh.frmMain:RegisterEvent("LOOT_SLOT_CLEARED");
			Elgoh.frmMain:RegisterEvent("LOOT_SLOT_CHANGED");
			Elgoh.frmMain:RegisterEvent("LOOT_CLOSED");
			Elgoh.frmMain:RegisterEvent("CHAT_MSG_RAID_WARNING");
			Elgoh.frmMain:RegisterEvent("CHAT_MSG_SYSTEM");
			RegisterAddonMessagePrefix("elgoh");
			Elgoh.HookTooltips();
			LootFrameDownButton:HookScript("OnClick", Elgoh.LootShow);
			LootFrameUpButton:HookScript("OnClick", Elgoh.LootShow);
		elseif(addon=="Blizzard_GuildUI") then
			if(partloaded==1) then Elgoh.frmMain:UnregisterEvent("ADDON_LOADED"); end
			partloaded=1;
			Elgoh.CreateGuildFrame();
			Elgoh.CreateMainFrame();
			GuildRosterContainer:HookScript("OnUpdate", function() Elgoh.GuildFrameUpdated() end);
		end
	elseif(event=="PLAYER_LOGIN") then
		Elgoh.Version=GetAddOnMetadata("elgoh", "X-Curse-Packaged-Version")
		if(Elgoh.Version==nil) then Elgoh.Version="r1"; end --it's NIL if using the working copy
		Elgoh.Version = string.sub(Elgoh.Version, 2); --gets rid of the r
		
		SendAddonMessage("elgoh", Elgoh.Version, "GUILD"); --Announce your version
		if(Elgoh_Settings==nil) then 
			ElPrint("Applying default settings...");
			Elgoh.frmSettings.default();
		end
		ElPrint("Version "..Elgoh.Version.." has been loaded");
		Elgoh.frmSettings.cancel();
	end
end