SLASH_ELGOH1 = "/elgoh";
SlashCmdList["ELGOH"] = function(msg, editBox)
	msg = string.lower(msg);
	if(msg=="options" or msg=="config" or msg=="settings") then
		InterfaceOptionsFrame_OpenToCategory("Elgoh");
		return;
	elseif(msg=="start") then
		if(CanEditOfficerNote()==false) then return; end
		Elgoh.StartDKP();
		return;
	elseif(msg=="import") then
		if(CanEditOfficerNote()==false) then 
			ElPrint("You cannot edit Officer notes");
			return; 
		end;
		Elgoh.LoadValues();
		SendChatMessage("Elgoh: Website EPGP has been imported", "OFFICER")
		return;
	else
		ElPrint("Available Commands:");
		ElPrint("import - Loads all values contained in the website export file (Irreversible; Make sure you're sure you wish to do this)(Requires Officer)");
		ElPrint("start - Generates a list of people in the same zone as you (for import into Guildlaunch) (Requires Officer)");
		ElPrint("config - Opens the options menu to configure Elgoh.");
		return;
	end
end

SLASH_READYCHECK1 = "/rc"
SlashCmdList["RC"] = function(msg, editBox)
	DoReadyCheck();
end

SLASH_LGOHB1 = "/breaktime"
SlashCmdList["LGOHB"] = function(msg, editBox)
	local Time=msg;
	if(Time=="") then Time=10; end
	if(IsAddOnLoaded("DBM-Core")) then	
		SendChatMessage(string.gsub(Elgoh_Settings["BreaktimeString"], "TIME", Time), "RAID")
		DBM:CreatePizzaTimer(60*Time, "Breaktime", 1, "the Officers")
	else
		ElPrint("Timers require Deadly Boss Mods");
	end
end

function Elgoh.controlOnEnter(self)
	GameTooltip:SetOwner(self, "ANCHOR_TOPRIGHT" );
	GameTooltip:SetText(self.tooltipText, nil, nil, nil, nil, 1 );
end

function Elgoh.CreateMainFrame()
	Elgoh.frmMain:SetAllPoints("GuildFrame");
	Elgoh.frmMain:SetPoint("TOPLEFT",GuildFrame,"TOPLEFT");
	Elgoh.frmMain:SetPoint("BOTTOMRIGHT",GuildFrame,"BOTTOMRIGHT");
	
	PanelTemplates_SetNumTabs(GuildFrame,6);
	GuildFrameTab6 = CreateFrame("Button","GuildFrameTab6",GuildFrame,"CharacterFrameTabButtonTemplate")
	GuildFrameTab6:SetScript("OnClick",function()
		CloseGuildMenus();
		PanelTemplates_SetTab(GuildFrame, 6);
		GuildFrame_ShowPanel("Elgoh.frmMain");
		ButtonFrameTemplate_HideButtonBar(GuildFrame);
		GuildFrameInset:SetPoint("TOPLEFT", 4, -65);
		GuildFrameInset:SetPoint("BOTTOMRIGHT", -7, 44);
		GuildFrameBottomInset:Hide();
		GuildPointFrame:Hide();
		GuildFactionFrame:Hide();
		GuildFrameMembersCountLabel:Hide();
		GuildFrameMembersCount:Hide();
	end);
	GuildFrameTab1:SetPoint("BOTTOMLEFT",-13,-30);
	GuildFrameTab6:SetPoint("LEFT",GuildFrameTab5,"RIGHT",-15,0)
	GuildFrameTab6:SetText("EPGP");
	GuildFrameTab6.tooltipText="Manage your guilds EPGP";
	GuildFrameTab6:SetScript( "OnEnter", Elgoh.controlOnEnter);
	GuildFrameTab6:SetScript( "OnLeave", GameTooltip_Hide);
	GuildFrame_RegisterPanel(Elgoh.frmMain);
	
	TempLabel = Elgoh.frmMain:CreateFontString( "ElgohTempText", "OVERLAY", "GameFontHighlight" );
	TempLabel:SetPoint( "CENTER", Elgoh.frmMain, 0, 0 );
	TempLabel:SetText("Work in Progress!");
	
	Elgoh.frmMain:SetScript("OnLoad", function() 
		this.elapsed=0;
	end);	
	
	Elgoh.frmMain:SetScript("OnShow", function() 
		PlaySound("UChatScrollButton");
	end);
	
	-- Elgoh.frmMainScroll1 = CreateFrame("ScrollFrame","Elgoh.frmMainScroll1",Elgoh.frmMainTabFrame1,"FauxScrollFrameTemplate")
	-- Elgoh.frmMainScroll1:SetScript("OnClick",function()
	-- ElgohScrollBar_Update(1)
	-- end);
	-- Elgoh.frmMainScroll1:SetPoint("CENTER",Elgoh.frmMain,"CENTER",0,0)

	--Elgoh.Model=CreateFrame("PlayerModel","Elgoh.Model",Elgoh.frmMain);
	--Elgoh.Model:SetAllPoints(Elgoh.frmMain);
	--Elgoh.Model:SetCamera(1);
	--Elgoh.Model:SetUnit("PLAYER");
end

function Elgoh.stripRealm(name)
	return gsub(name, "%-[^|]+", "");
end

function Elgoh.AllowToMove(frame)
	frame:EnableMouse(true)
	frame:SetMovable(true);
	frame:SetClampedToScreen(true);
	frame:RegisterForDrag("LeftButton");
	frame:SetScript("OnDragStart", frame.StartMoving);
	frame:SetScript("OnDragStop", frame.StopMovingOrSizing);
end

function ElPrint(...)
	local message=strjoin(" ", tostringall(...));
	message="|cff66ff33Elgoh:|r "..message;
	print(message);
end

function ElDebug(...)
	message=strjoin(" ", tostringall(...));
	if(Elgoh_Settings.Debug==1 and message~=nil) then
		message="|cff119900Elgoh:|r "..message;
		print(message);
	end
end