Elgoh.frmSettings = CreateFrame("Frame");
Elgoh.frmSettings.name = "Elgoh";
--Elgoh.frmSettings:Hide();

Elgoh.Settings_Default={
	["EPGPThreshhold"]=750,
	["Debug"]=false,
	["MiniLvl"]=476,
	["BreaktimeString"]="Breaktime! Be back in TIME minutes!",
	["MSString"]="Roll for ITEM Mainspec",
	["StartBonus"]=50,
}

Elgoh.frmSettings.okay = function() 
	Elgoh_Settings={};
	Elgoh_Settings["Debug"]=Debug:GetChecked();
	Elgoh_Settings["BreaktimeString"]=Breaktime:GetText();
	Elgoh_Settings["MiniLvl"]=tonumber(ilvlBox:GetText());
	Elgoh_Settings["EPGPThreshhold"]=tonumber(threshholdBox:GetText());
	Elgoh_Settings["MSString"]=Mainspec:GetText();
	Elgoh_Settings["StartBonus"]=tonumber(StartBonusBox:GetText());
end

function Elgoh.frmSettings.cancel()
	Debug:SetChecked(Elgoh_Settings.Debug);
	Breaktime:SetText(Elgoh_Settings.BreaktimeString);
	ilvlBox:SetText(Elgoh_Settings.MiniLvl);
	threshholdBox:SetText(Elgoh_Settings.EPGPThreshhold)
	Mainspec:SetText(Elgoh_Settings.MSString);
	StartBonusBox:SetText(Elgoh_Settings.StartBonus);
end

function Elgoh.frmSettings.default() 
	Elgoh_Settings=Elgoh.Settings_Default;
	Elgoh.frmSettings.cancel();
end

-- Pane title
Title = Elgoh.frmSettings:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge" );
Title:SetPoint( "TOPLEFT", 16, -16 );
Title:SetText("ELGoH");
SubText = Elgoh.frmSettings:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall" );
SubText:SetPoint("TOPLEFT", Title, "BOTTOMLEFT", 0, -8 );
SubText:SetPoint("RIGHT", -32, 0 );
SubText:SetHeight(32);
SubText:SetJustifyH( "LEFT" );
SubText:SetJustifyV( "TOP" );
SubText:SetText("General settings, this part is a work in progress so more settings will be added with each update");

-- Miscellaneous checkboxes
Debug = CreateFrame("CheckButton", "ElgohDebugCheckbox", Elgoh.frmSettings, "InterfaceOptionsCheckButtonTemplate");
Debug:SetPoint( "LEFT", SubText, "LEFT", -2, 0 );
Debug:SetPoint( "BOTTOM", Elgoh.frmSettings, "BOTTOM", 0, 10 );
getglobal(Debug:GetName() .. "Text"):SetText("Enable Debug Mode");
Debug.tooltipText = "Enable Debug Mode";

-- Breaktime
BreakLabel = Elgoh.frmSettings:CreateFontString( nil, "ARTWORK", "GameFontHighlight" );
BreakLabel:SetPoint( "TOPLEFT", SubText, "BOTTOMLEFT", -0, -10 );
BreakLabel:SetText("Text to post during /breaktime");

Breaktime = CreateFrame("EditBox", "ElgohBreaktimeBox", Elgoh.frmSettings, "InputBoxTemplate")
Breaktime:SetWidth(400)
Breaktime:SetHeight(20)
Breaktime:SetPoint("TOP", BreakLabel, "TOP", 0,2);
Breaktime:SetPoint("LEFT", BreakLabel, "RIGHT", 15,0);
Breaktime:SetAutoFocus(false)
Breaktime:SetScript("OnEnterPressed", function() Elgoh.frmSettings:ClearFocus(); end)
Breaktime.tooltipText="TIme will be replaced with the time in minutes";
Breaktime:SetScript( "OnEnter", Elgoh.controlOnEnter);
Breaktime:SetScript( "OnLeave", GameTooltip_Hide);

-- Mainspec
MainspecLabel = Elgoh.frmSettings:CreateFontString( nil, "ARTWORK", "GameFontHighlight" );
MainspecLabel:SetPoint( "TOPLEFT", BreakLabel, "BOTTOMLEFT", -0, -30 );
MainspecLabel:SetText("What to post for Mainspec Rolls");

Mainspec = CreateFrame("EditBox", "Elgoh.MainspecBox", Elgoh.frmSettings, "InputBoxTemplate")
Mainspec:SetWidth(400)
Mainspec:SetHeight(20)
Mainspec:SetPoint("TOP", MainspecLabel, "TOP", 0,0);
Mainspec:SetPoint("LEFT",Breaktime, "LEFT", 0,0);
Mainspec:SetAutoFocus(false)
Mainspec:SetScript("OnEnterPressed", function()MainspecLabel:ClearFocus(); end)
Mainspec.tooltipText="\"ITEM\" will be replace with the item link";
Mainspec:SetScript( "OnEnter",Elgoh.controlOnEnter);
Mainspec:SetScript( "OnLeave", GameTooltip_Hide);

--ItemLevel
ilvlBox = CreateFrame("EditBox", "ElgohilvlBox", Elgoh.frmSettings, "InputBoxTemplate")
ilvlBox:SetWidth(60)
ilvlBox:SetHeight(20)
ilvlBox:SetPoint("TOP",Breaktime, "BOTTOM", 0,-2);
ilvlBox:SetPoint("LEFT",Breaktime, "LEFT", 0,0);
ilvlBox:SetAutoFocus(false)
ilvlBox:SetJustifyH("CENTER");
ilvlBox:SetScript("OnEnterPressed", function()ilvlBox:ClearFocus(); end)
ilvlBox.tooltipText="The minimum Item Level of gear to display EPGP values for";
ilvlBox:SetScript( "OnEnter", Elgoh.controlOnEnter );
ilvlBox:SetScript( "OnLeave", GameTooltip_Hide );

--Threshhold
threshholdBox = CreateFrame("EditBox", "ElgohThreshholdBox", Elgoh.frmSettings, "InputBoxTemplate")
threshholdBox:SetWidth(60)
threshholdBox:SetHeight(20)
threshholdBox:SetPoint("TOP",ilvlBox, "TOP", 0,0);
threshholdBox:SetPoint("LEFT",ilvlBox, "RIGHT", 30,0);
threshholdBox:SetAutoFocus(false)
threshholdBox:SetJustifyH("CENTER");
threshholdBox:SetScript("OnEnterPressed", function()threshholdBox:ClearFocus(); end)
threshholdBox.tooltipText="The EPGP Threshhold. This only matters if you are the Master Looter";
threshholdBox:SetScript( "OnEnter",Elgoh.controlOnEnter );
threshholdBox:SetScript( "OnLeave", GameTooltip_Hide );

--StartBonus
StartBonusBox = CreateFrame("EditBox", "Elgoh.StartBonusBox", Elgoh.frmSettings, "InputBoxTemplate")
StartBonusBox:SetWidth(60)
StartBonusBox:SetHeight(20)
StartBonusBox:SetPoint("TOP",ilvlBox, "TOP", 0,0);
StartBonusBox:SetPoint("LEFT",threshholdBox, "RIGHT", 30,0);
StartBonusBox:SetAutoFocus(false)
StartBonusBox:SetJustifyH("CENTER");
StartBonusBox:SetScript("OnEnterPressed", function()StartBonusBox:ClearFocus(); end)
StartBonusBox.tooltipText="The bonus EP to award anyone on the start bonus list";
StartBonusBox:SetScript( "OnEnter",Elgoh.controlOnEnter );
StartBonusBox:SetScript( "OnLeave", GameTooltip_Hide );

InterfaceOptions_AddCategory(Elgoh.frmSettings);